<?php $scrpt_vrsn_dt  = 'AQ_wh45_popup.php|01|2021-12-31|';  # PHP8 | release 2012_lts
# 
# -----------------     SETTINGS for this script
$co2_lvls       = array (0, 400, 1000, 1500, 2000, 5000);
#       level = 1  # 0 to 400        Excellent                      Green
#       level = 2  # 400 to 1000     Fine, unbedenklich             Green
#       level = 3  # 1000 to 1500    Moderate, Lueften              Yellow
#       level = 4  # 1500 to 2000    Poor, Lueften!                 Red
#       level = 5  # 2000 to 5000    Very Poor, inakzeptabel        Purple
#       level = 6  # from 5000       Severe                         Maroon
#
# there's only ONE WH45
$co2_name           = 'WH45 sensor';
#
#$show_close_x      = false;       // the close X in the top left: default we use easyweather settings , set to false or true to override
#$show_close_x      = true;        // remove the # for the line if you want to override to set false or true
#
$station_link       = '';
$explain_link       = 'https://www.airnow.gov/aqi/aqi-basics/';
$co2_explain_link   = 'https://www.breeze-technologies.de/de/blog/calculating-an-actionable-indoor-air-quality-index/';
$popup_css          = './css/popup_css.css';
#
# ------------------------------     texts used
$ltxt_clsppp        = 'Close';
$ltxt_info          = 'More information';
$ltxt_aq_info       = 'Air Quality Index';
$ltxt_co2_info      = 'indoor air quality index';
$ltxt_luftdaten     = 'Station sensor';
$ltxt_url           = 'Our CO2 sensor';
$ltxt_sensor        = 'Sensor data captured at';
$ltxt_id            = 'Sensor_ID';
$ltxt_crrnt         = 'Current';
$ltxt_24h           = '24 hours';
$ltxt_pm10          = 'PM10';
$ltxt_pm25          = 'PM25';
$ltxt_co2           = 'CO2';
$ltxt_disclaim2     = 'The health effects should be based on 24 hours average values only.';
$htxt_period        = 'period';
$htxt_particle      = 'particle';
$htxt_contration    = 'concentration';
$htxt_AQI           = 'AQI';
$htxt_risk          = 'Risk';
$htxt_loc           = 'Location';
#
$clssfctn_txts      = array();
$clssfctn[7]        = 'unkown / error in data';
$clssfctn[6]        = 'Health alert: everyone may experience more serious health effects';
$clssfctn[5]        = 'Health warnings of emergency conditions. The entire population is more likely to be affected';
$clssfctn[4]        = 'Everyone may begin to experience health effects; members of sensitive groups may experience more serious health effects.';
$clssfctn[3]        = 'Members of sensitive groups may experience health effects. The general public is not likely to be affected.';
$clssfctn[2]        = 'Air quality is acceptable; however, for some pollutants there may be a moderate health concern for a very small number of people who are unusually sensitive to air pollution.';
$clssfctn[1]        = 'Air quality is considered satisfactory, and air pollution poses little or no risk';
#-----------------------------------------------
#         PWS-Dashboard - Updates and support by 
#     Wim van der Kuil https://pwsdashboard.com/
#-----------------------------------------------
#       display source of script if requested so
#-----------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
        $filenameReal = __FILE__;  
        $download_size = filesize($filenameReal);
        header('Pragma: public');
        header('Cache-Control: private');
        header('Cache-Control: no-cache, must-revalidate');
        header('Content-type: text/plain; charset=UTF-8');
        header('Accept-Ranges: bytes');
        header("Content-Length: $download_size");
        header('Connection: close');
        readfile($filenameReal);
        exit;}
elseif (!isset ($_REQUEST['test'])) 
     {  ini_set('display_errors', 0);   error_reporting(0);}
else {  ini_set('display_errors','On'); error_reporting(E_ALL);}  
header('Content-type: text/html; charset=UTF-8');
# -------------------save list of loaded scrips;
if (!isset ($stck_lst) ) {$stck_lst = '';}
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') version =>'.$scrpt_vrsn_dt.PHP_EOL;       
#
# -------------load weatherdata and all settings 
$scrpt          = 'PWS_livedata.php'; 
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') include_once =>'.$scrpt.PHP_EOL;
include_once $scrpt; 
#-----------------------------------------------
#     check if data is usable
#-----------------------------------------------
$dataFALSE              = '';
if (! array_key_exists ('pm25_co2', $weather) ) 
     {  $dataFALSE = __LINE__.': No WH45 sensor found'; }
if ($dataFALSE<> '')
     {  echo 'Problem '.$dataFALSE.'<br />Check settings and data'; return;}
#-----------------------------------------------
#      general functions / tables for AQ scripts
#-----------------------------------------------
$scrpt          = 'AQ_shared.php';  
$stck_lst      .= basename(__FILE__).' ('.__LINE__.') include  =>'.$scrpt.PHP_EOL; 
include_once $scrpt;  
#-----------------------------------------------
#                        get the data to display 
#----------------------------------------------- 
$aq_unix        = $weather['datetime'];
$values         = array();

# gather WH45-sensor
$key    = 'pm25_co2';
$wert                   = (float) $weather[$key];
$values['pm25']         = number_format($wert,1 );
$values['pm25_aq']      = number_format(pm25_to_aqi($wert),1 );
$values['text']         = lang($co2_name);
#
$key    = 'pm25_co2_24avg';
if (array_key_exists ($key, $weather) ) 
     {  $wert                   = (float) $weather[$key];
        $values['pm25_avg']     = number_format($wert,1 );
        $values['pm25_avg_aq']  = number_format(pm25_to_aqi($wert),1 ); }
else {  $values['pm25_avg']     = false; }
#
$key    = 'pm10_co2';
if (array_key_exists ($key, $weather) ) 
     {  $wert                   = (float) $weather[$key];
        $values['pm10']         = number_format($wert,1 );
        $values['pm10_aq']      = number_format(pm10_to_aqi($wert),1 ); }
else {  $values['pm10']         = false; }
#
$key    = 'pm10_co2_24avg';
if (array_key_exists ($key, $weather) ) 
     {  $wert                   = (float) $weather[$key];
        $values['pm10_avg']     = number_format($wert,1 );
        $values['pm10_avg_aq']  = number_format(pm10_to_aqi($wert),1 ); }
else {  $values['pm10_avg']     = false; }
#
$key    = 'co2';
if (array_key_exists ($key, $weather) ) 
     {  $wert                   = (int) $weather[$key];
        $values['co2']          = $wert;
        $values['co2_aq']       = CO2level($wert); }
else {  $values['co2']          = false; }
#             print "* oli ************************* wert: ".$wert." level: ".CO2level($wert)." im Array: ".$values['co2_aq'];
$key    = 'co2_24avg';
if (array_key_exists ($key, $weather) ) 
     {  $wert                   = (int) $weather[$key];
        $values['co2_avg']      = $wert;
        $values['co2_avg_aq']   = CO2level($wert);} 
else {  $values['co2_avg']      = false; }
#
$key    = 'humi_co2';
if (array_key_exists ($key, $weather) ) 
     {  $wert                   = (float) $weather[$key];
        $values['humi_co2']     = number_format($wert,1 ); }
else {  $values['humi_co2']     = false; }
#
$key    = 'tf_co2';
if (array_key_exists ($key, $weather) ) 
     {  $wert                   = (float) $weather[$key];
        $values['tf_co2']       = number_format($wert,1 ); }
else {  $values['tf_co2']       = false; }

#echo '<pre>'.__LINE__.print_r($values,true); exit;
#
# --------------------------------   test values
#$pm10           = 100;
#$pm25           = 11;
# --------------------------------   test values
#
$ltxt_url       = lang($ltxt_url);
#
# normally we use the easyweather settings
if (isset ($show_close_x) )
     {  if ($show_close_x === false || $show_close_x === true)  
             { $close_popup = $show_close_x;}
        }
if ($close_popup === true) 
     {  $close  = '      <span style="float: left; ">&nbsp;X&nbsp;&nbsp;<small>'.lang($ltxt_clsppp).'</small></span>'.PHP_EOL;}
else {  $close = '';}
#
echo '<!DOCTYPE html>
<html lang="'.substr($user_lang,0,2).'">
<head>
    <meta charset="UTF-8">
    <title>'.$ltxt_url.'</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
'.my_style().'
</head>
<body class="dark" style="background-color: transparent; font-size: 10px;">
    <div class="PWS_module_title" style="width: 100%; font-size: 14px; padding-top: 4px;">
'.$close.'
   <span style="color: #FF7C39; ">'.$ltxt_url.'</span>
    </div>'.PHP_EOL;
#
$arrow_black  = '<td> <div style="border-left:10px solid transparent;
border-right:10px solid transparent;
border-top:10px solid #000;
height:0;
width:0;
margin:0 auto;
"></div></td>';
#
$nr_data_coloms = 6;    // nr of values in the table
$str_hr         = '<tr style="height: 4px;"><td style="height: 4px;" colspan ="'.($nr_data_coloms+$nr_blocks ).'"><hr /></td></tr>'.PHP_EOL;
$string        = '<div style="display: block;  width: 100%;  background-color: white; color: black;">
<br />
<table class="" style = "width: 98%; border-collapse: collapse; margin: 0 auto;">
<tr> 
<th style="text-align: left;   "><small>'.    lang($htxt_period)        .'</small></th>
<th style="text-align: left;   "><small>'.    lang($htxt_loc)           .'</small></th>
<th style="text-align: left;    "><small>'.   lang($htxt_particle)      .'</small></th>
<th style="text-align: left;   "><small>'.    lang($htxt_contration)    .'</small></th>
<th style="text-align: center; "><small>'.    lang($htxt_AQI )          .'</small></th>
<th style="text-align: left;    "><small>'.   lang($htxt_risk)          .'</small></th>'.PHP_EOL;
$string         .= str_repeat ('<th>&nbsp;</th>',$nr_blocks); # echo __LINE__.' $nr_blocks = '.$nr_blocks; exit;
$string         .= '</tr>'.PHP_EOL;
echo $string; 
$strng_crnt     = $strng_avg = '';
$text   = $values['text'];

$valarr = array("pm25","pm10","co2","pm25_avg","pm10_avg","co2_avg");
$co2_color  = array ('#ff7e00', '#00e400', '#00e400', '#ffff00', '#ff0000', '#8f3f97', '#7e0023');
$co2_text   = array ('Unknown', 'Excellent', 'Fine', 'Moderate', 'Poor', 'Very Poor', 'Severe');
$co2_class  = array ('unknown', 'green', 'green', 'yellow', 'red', 'purple', 'maroon');
$co2_levels = array ('0','1','2','3','4','5','6');
$co2_limits = array ('unknown', '0 .. 400', '400 .. 1000', '1000 .. 1500', '1500 .. 2000', '2000 .. 5000', ' > 5000');
$co2_func   = array ('unknown','Excellent air','Fine air','Moderate air, ventilation recommended','Poor air, ventilation necessary','Very poor air, unacceptable','Severe air, leave the room');

$hrdone = false;
foreach ($valarr as $key) {
  if (array_key_exists ($key, $values) ) {
    if (strpos($key,'co2') === false) {
      $unit = " ug/m3";
      $arr  = aq_set_clrs ($values[$key.'_aq']);
      $clmn  = $arr['clmn'];
      $risk   = lang($arr['text']); 
    } else { 
      $unit = " ppm";
      $lvl = $values[$key.'_aq'];
      if ($lvl == 2) { $clmn = 1;} elseif ($lvl == 3) { $clmn = 2; } else { $clmn = $lvl; }
      $risk   = lang($co2_text[$values[$key.'_aq']]);
    }
    if (strpos($key,'avg') === false) {
      $ltxt_when = $ltxt_crrnt;
    } else {
      $ltxt_when = $ltxt_24h;
      if (! $hrdone) { $strng_crnt .= $str_hr; $hrdone = true; }
    }
    $part = substr($key,0,strpos($key,"_"));
    if ($part == "") { $part = $key; }
    $strng_crnt .= '<tr><td style="text-align: left;"><small>'.lang($ltxt_when).'</small></td>
<td style="text-align: left;"><small>'.lang($text).'</small></td>
<td style="text-align: left;"><small>'.lang(${'ltxt_'.$part}).'</small></td>
<td style="text-align: left;"><small>'.$values[$key].$unit.'</small></td>
<td style="text-align: center;"><small><b>'.$values[$key.'_aq'].'</b></small></td>
<td style="text-align: left;"><small>'.$risk.'</small></td>'.PHP_EOL;
    for ($p = 1; $p <= $nr_blocks ; $p++) {
      if ($clmn == $p) {
        $strng_crnt .= $arrow_black; }
      else {  $strng_crnt .= '<td>&nbsp;</td>'; }
    }
    $strng_crnt .= '</tr>'.PHP_EOL;
  }
}


#echo "* oli ************************************".__LINE__.print_r($values,true); exit;
#echo "* oli ************************************ ".$key.' '.$values['co2'];

#
echo $strng_crnt.$str_hr.$strng_avg;
#
$string = '<tr>'.str_repeat('<td>&nbsp;</td>',$nr_data_coloms).PHP_EOL;
$width_color = floor(50/$nr_blocks);
for ($n = 1; $n <= $nr_blocks; $n++) 
     {  $string .= '<td style = "width: '.$width_color.'%; text-align: center; border: 1px solid grey; font-weight:bold;"'
                        .' class= "'.$aq_class[$n].'">'.'</td>'.PHP_EOL;}
$string .= '</tr>'.PHP_EOL;
echo $string;
echo  '</table><br />'.PHP_EOL;  
#----------------------------------------------- 
#---------------------------   EXPLANATION BLOCK
#-----------------------------------------------
$coloms         = array ('band','index','P25','P10','risk');
$nr_cols        = count($coloms);
$string = '<table style="text-align: center; width: 98%; margin: 0 auto; border-collapse: collapse; border: 1px solid grey;">
<thead style="background-color: #ccc;">
<tr style="border-bottom: 1px solid grey;">'.PHP_EOL;
$string .= '<th style="width: 22%;"><small>'.lang('classification').'</small></th>'.PHP_EOL;
$string .= '<th style="width: 8%;"><small>'.lang('AQI')           .'</small></th>'.PHP_EOL;
$string .= '<th style="width: 10%;"><small>'.lang('pm10')          .'</small></th>'.PHP_EOL;
$string .= '<th style="width: 10%;"><small>'.lang('pm2.5')         .'</small></th>'.PHP_EOL;
$string .= '<th style="width: 50%;"><small>'.lang($ltxt_disclaim2) .'</small></th>'.PHP_EOL;
$string .= '</tr></thead>
<tbody>'.PHP_EOL;
echo $string;
$explain= '';
$rowspan= '';  # 'rowspan="'.$rowspan.'" ';
for ($p = 1; $p <= $nr_blocks; $p++) 
    {   $explain .= ' <tr style="border-bottom: 1px solid grey;">'.PHP_EOL;
        $explain .=  '<td style="font-weight:bold;" class= "' 
                .$aq_class[$p].'">' 
                .lang($aq_text[$p]).'</td>'.PHP_EOL;
        $explain .= '<td style="font-weight:bold; border: 1px solid grey;">';       
        if ($p == 0) 
             {  $explain .= '1-'.$AQ_levels[$p].'</td>'.PHP_EOL;}
        elseif ($p < $nr_blocks)
             {  $explain .= $AQ_levels[$p-1] .'-'.$AQ_levels[$p].'</td>'.PHP_EOL;}
        else {  $explain .= '> '.$AQ_levels[$p-1].'</td>'.PHP_EOL;}
        $extra = '';
        if ($p < $nr_blocks) 
             {  $tekst  = '<small>&lt;&nbsp;'.$pm10_levels[$p].'&nbsp;&mu;g/m<sup>3</sup></small>';}
        else {  $tekst  = '<small>&gt;&nbsp;'.$pm10_levels[$p-1].'&nbsp;&mu;g/m<sup>3</sup></small>';}
        $explain .= '<td style="border: 1px solid grey;">'.$tekst.'</td>'.PHP_EOL;
        if ($p < $nr_blocks) 
             {  $tekst  = '<small>&lt;&nbsp;'.$pm25_levels[$p].'&nbsp;&mu;g/m<sup>3</sup></small>';}
        else {  $tekst  = '<small>&gt;&nbsp;'.$pm25_levels[$p-1].'&nbsp;&mu;g/m<sup>3</sup></small>';}
        $explain .= '<td style="border: 1px solid grey;">'.$tekst.'</td>'.PHP_EOL;
        $explain .= '<td '.$rowspan.' style="max-width: 50%;"><small>'.lang($clssfctn[$p]).'</small></td></tr>'.PHP_EOL;
             
        }
#
$explain .= '<tr style="background-color: #ccc;"><td colspan="'.$nr_cols.'" style="border-top: 1px solid grey;">&nbsp;'
        .lang($ltxt_info).':&nbsp;'
        .'<a href="'.$explain_link.'" target="_blank">'
        .strtoupper($aqhi_type).'&nbsp;&nbsp;'.lang($ltxt_aq_info).'</a>&nbsp;&nbsp;&nbsp;&nbsp;<small>'
        .lang($ltxt_sensor).':&nbsp;'.date($dateFormat.' '.$timeFormatShort,$aq_unix).' &nbsp;'
        .'</small></td></tr>
</tbody>
</table>
<br />
</div>'.PHP_EOL;
echo $explain;

# CO2
$string = '<div style="display: block;  width: 100%;  background-color: white; color: black;">'.PHP_EOL;
$string .= '<table style="text-align: center; width: 98%; margin: 0 auto; border-collapse: collapse; border: 1px solid grey;">
<thead style="background-color: #ccc;">
<tr style="border-bottom: 1px solid grey;">'.PHP_EOL;
$string .= '<th style="width: 22%;"> <small>'.lang('classification').'</small></th>'.PHP_EOL;
$string .= '<th style="width: 8%;"><small>'.lang('Level').'</small></th>'.PHP_EOL;
$string .= '<th style="width: 20%;"><small>'.lang('CO2').'</small></th>'.PHP_EOL;
$string .= '<th style="width: 50%;"><small>'.lang($ltxt_disclaim2) .'</small></th>'.PHP_EOL;
$string .= '</tr></thead>
<tbody>'.PHP_EOL;
echo $string;

$explain= '';
$rowspan= '';  # 'rowspan="'.$rowspan.'" ';
for ($p = 1; $p <= $nr_blocks; $p++)
    {   $explain .= ' <tr style="border-bottom: 1px solid grey;">'.PHP_EOL;
        $explain .=  '<td style="font-weight:bold;" class= "'
                .$co2_class[$p].'">'
                .lang($co2_text[$p]).'</td>'.PHP_EOL;
        $explain .= '<td style="font-weight:bold; border: 1px solid grey;">';
        if ($p > 0) {  $explain .= $co2_levels[$p]; }
        $explain .= '</td>'.PHP_EOL;
        $extra = '';
        $tekst  = '<small>&nbsp;'.$co2_limits[$p].'&nbsp;ppm</small>';
        $explain .= '<td style="border: 1px solid grey;">'.$tekst.'</td>'.PHP_EOL;
        $explain .= '<td '.$rowspan.' style="max-width: 50%;"><small>'.lang($co2_func[$p]).'</small></td></tr>'.PHP_EOL;
        }
#
$explain .= '<tr style="background-color: #ccc;"><td colspan="4" style="border-top: 1px solid grey;">&nbsp;'
        .lang($ltxt_info).':&nbsp;'.'<a href="'.$co2_explain_link.'" target="_blank">'.lang($ltxt_co2_info).'</a>&nbsp;&nbsp;&nbsp;&nbsp;<small>'
        .lang($ltxt_sensor).':&nbsp;'.date($dateFormat.' '.$timeFormatShort,$aq_unix).' &nbsp;'
        .'</small></td></tr>
</tbody>
</table>
<br />
</div>'.PHP_EOL;
echo $explain;

#

if (isset ($_REQUEST['test'] ) ) {echo '<!-- '.$stck_lst.' -->'; } 
echo '</body>
</html>'.PHP_EOL;
#
# style is printed in the header 
function my_style()
     {  global $popup_css , $nr_blocks, $aq_class, $aq_color, $aq_color_txt;
        $return         = PHP_EOL.'    <style>'.PHP_EOL;
# load the genral css for pop-ups
        if (isset ($popup_css) && $popup_css <> false)  
             {  $return .= file_get_contents ($popup_css);}
        for ($n = 1; $n <= $nr_blocks; $n++)
             {  $return .= '.'.$aq_class[$n].' { background: '.$aq_color[$n].'; color: '.$aq_color_txt[$n].';}'.PHP_EOL;
             }
/*$return .='
        .green  { background: rgb(  0, 228,   0); color: black;}
        .yellow { background: rgb(255, 255,   0); color: black;}
        .orange { background: rgb(255, 126,   0); color: black;}
        .red    { background: rgb(255,   0,   0); color: black;}
        .purple { background: rgb(143,  63, 151); color: white;}
        .maroon { background: rgb(126,   0,  35); color: white;}
';  */           
# add pop-up specific css
        $return         .= '    </style>'.PHP_EOL;
        return $return;

 }
#
function CO2level($co2) {
        global $co2_lvls;
        $co2    = (int) $co2;
        if ($co2 == 0)                {  return 0; }
        if ($co2 <= $co2_lvls[1])     {  return 1; }  # level = 1  # 0 to 400        Excellent                      Green
        elseif ($co2 <= $co2_lvls[2]) {  return 2; }  # level = 2  # 400 to 1000     Fine, unbedenklich             Green
        elseif ($co2 <= $co2_lvls[3]) {  return 3; }  # level = 3  # 1000 to 1500    Moderate, Lueften              Yellow
        elseif ($co2 <= $co2_lvls[4]) {  return 4; }  # level = 4  # 1500 to 2000    Poor, Lueften!                 Red
        elseif ($co2 <= $co2_lvls[5]) {  return 5; }  # level = 5  # 2000 to 5000    Very Poor, inakzeptabel        Purple
        else                          {  return 6; }    # level = 6  # from 5000       Severe                         Maroon
}

